extern (C):

alias void IoState;
alias void IoObject;
alias IoObject IoString;
alias IoObject IoMessage;
alias IoObject IoNumber;
alias IoObject *(IoMethodFunc)(IoObject *, IoObject *, IoMessage *);

IoState *IoState_new();
void IoState_pauseGarbageCollector(IoState *self);
void IoState_resumeGarbageCollector(IoState *self);

IoObject *IoState_lobby(IoState *self);

IoObject *IoNil_new(void *state);
IoNumber *IoNumber_newWithDouble_(void *state, double n);
IoMessage *IoMessage_newWithName_(IoState *state, IoString *symbol);
IoString *IoState_stringWithCString_(IoState *self, char *s);

int IoNumber_asInt(IoNumber *self);
double IoNumber_asDouble(IoNumber *self);

void IoObject_addMethod_(IoObject *self, IoString *slotName, IoMethodFunc *fp);
IoObject *IoObject_perform(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoObject_asyncPerform(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoObject_getSlot_(IoObject *self, IoString *slotName);
void IoObject_setSlot_to_(IoObject *self, IoString *slotName, IoObject *value);

IoObject *IoState_doCString_(IoState *self, char *s);
IoObject *IoState_doFile_(IoState *self, char *fileName);

void IoMessage_addCachedArg_(IoMessage *self, IoObject *v);
void IoMessage_addArg_(IoMessage *self, IoMessage *v);
IoObject *IoMessage_locals_valueArgAt_(IoMessage *self, IoObject *locals, int n);
int IoMessage_locals_intArgAt_(IoMessage *self, IoObject *locals, int n);
long IoMessage_locals_longArgAt_(IoMessage *self, IoObject *locals, int n);
double IoMessage_locals_doubleArgAt_(IoMessage *self, IoObject *locals, int n);
float IoMessage_locals_floatArgAt_(IoMessage *self, IoObject *locals, int n);
IoObject *IoMessage_locals_stringArgAt_(IoMessage *self, IoObject *locals, int n);
char *IoMessage_locals_cStringArgAt_(IoMessage *self, IoObject *locals, int n);

private import std.string;

IoObject* DIoObject_perform(IoState* state, IoObject* target, char[] s) {
    IoString* str = IoState_stringWithCString_(state, toStringz(s));
    IoMessage* msg = IoMessage_newWithName_(state, str);
    IoObject* lobby = IoState_lobby(state);
    return IoObject_perform(target, lobby, msg);
}

IoObject* DIoObject_getSlot(IoState* state, IoObject* target, char[] s) {
    IoString* str = IoState_stringWithCString_(state, toStringz(s));
    return IoObject_getSlot_(target, str);
}

void DIoObject_setSlot_to(IoState *state, IoObject *self,
                           char[] s, IoObject *value) {
    IoString* str = IoState_stringWithCString_(state, toStringz(s));
    IoObject_setSlot_to_(self, str, value);
}

void DIoObject_addMethod(IoState *state, IoObject *self,
                          char[] s, IoMethodFunc *fp) {
    IoString* str = IoState_stringWithCString_(state, toStringz(s));
    IoObject_addMethod_(self, str, fp);
}
