private import charactor;
private import game;
private import shot;
private import common;
private import objspecs;
private import opengl;
private import texture;
private import player;
private import enemy_view;

private import std.math;

extern(C) void enemy_perform(void* h, char[] msg);
extern(C) void* enemy_begin(Enemy e, char[] name);
extern(C) void enemy_end(void* h);

class Enemy : Charactor {
    mixin HasLife;
    mixin HasRelativePush;

    this(float x, float y) {
        handle_ = enemy_begin(this, "test");

        x_ = x;
        y_ = y;

        alive_ = true;

        view_ = new ProtonView(x_, y_);
    }

    ~this() {
        enemy_end(handle_);
    }

    override void move() {
        if (wait_ > 0) {
            wait_--;
            if (wait_ == 0) enemy_perform(handle_, "resume");
        }

        super.move();

        view_.setXY(x_, y_);
        view_.move();
    }

    override void draw() {
        if (!Game.obj.isInside(x_, y_, 10)) return;

        view_.draw();
    }

    // for bug?
	override bit alive() { return alive_; }

private:
    void* handle_;

    View view_;

    int wait_;

public:
    // --- for Io ---

    void shotAbs(float s, float a) {
        Game.obj.addShot(new Shot(x_, y_, s*sin(a), s*cos(a)));
    }

    void shotAbsXY(float sx, float sy) {
        Game.obj.addShot(new Shot(x_, y_, sx, sy));
    }

    void sleep(int t) {
        wait_ = t;
        if (wait_ > 0) enemy_perform(handle_, "pause");
        else enemy_perform(handle_, "yield");
    }

    float getPlayerAngle() {
        Player p = Game.obj.player;
        return angle(x_, y_, p.x, p.y);
    }

    void setSpeedXY(float sx, float sy) {
        sx_ = sx;
        sy_ = sy;
    }

}

