private import enemy;
private import dio;
private import common;

IoState* ioState;
void*[char[]] enemies;
Enemy[void*] handle2enemy;
void*[void*] handle2future;

static this() {
    ioState = IoState_new();
    IoState_pauseGarbageCollector(ioState);

    IoObject* lobby = IoState_lobby(ioState);

    IoObject* number = DIoObject_getSlot(ioState, lobby, "Number");
    IoObject* enemy = DIoObject_perform(ioState, number, "clone");

    DIoObject_addMethod(ioState, lobby, "registEnemy", &io_regist_enemy);

    enemy_init(ioState, enemy);

    DIoObject_setSlot_to(ioState, lobby, "Enemy", enemy);

    IoState_doFile_(ioState, "data/enemy/test.io");

    IoState_resumeGarbageCollector(ioState);
}

extern (C):

IoObject* io_regist_enemy(IoObject *self, IoObject *locals, IoMessage *m) {
    char[] s = tostr(IoMessage_locals_cStringArgAt_(m, locals, 0));
    IoObject* e = IoMessage_locals_valueArgAt_(m, locals, 1);
    enemies[s] = e;

//    Log.info(s ~ ": register enemy");

    return IoNil_new(ioState);
}

void enemy_perform(void* handle, char[] msg) {
    DIoObject_perform(ioState, handle, msg);
}

void io_yield() {
    IoObject* lobby = IoState_lobby(ioState);
    DIoObject_perform(ioState, lobby, "yield");
}

IoObject* enemy_begin(Enemy e, char[] name) {
    IoObject* enemy = enemies[name];
    IoObject* handle = DIoObject_perform(ioState, enemy, "clone");
    handle2enemy[handle] = e;

    // run
    IoString* msgStr = IoState_stringWithCString_(ioState, "@");
    IoMessage* msg = IoMessage_newWithName_(ioState, msgStr);
    IoString* argStr = IoState_stringWithCString_(ioState, "move");
    IoMessage* arg = IoMessage_newWithName_(ioState, argStr);
    IoMessage_addArg_(msg, arg);

    IoObject* lobby = IoState_lobby(ioState);
    IoObject_asyncPerform(handle, lobby, msg);

    return handle;
}

void enemy_end(void* handle) {
    delete handle2enemy[handle];
}

// --- generated codes ---

IoObject* io_enemy_shotAbs(IoObject* self, IoObject* locals, IoMessage* m) {
    Enemy elcl = handle2enemy[self];
    float s = IoMessage_locals_floatArgAt_(m, locals, 0);
    float a = IoMessage_locals_floatArgAt_(m, locals, 1);
    elcl.shotAbs(s, a);
    return IoNil_new(ioState);
}

IoObject* io_enemy_shotAbsXY(IoObject* self, IoObject* locals, IoMessage* m) {
    Enemy elcl = handle2enemy[self];
    float sx = IoMessage_locals_floatArgAt_(m, locals, 0);
    float sy = IoMessage_locals_floatArgAt_(m, locals, 1);
    elcl.shotAbsXY(sx, sy);
    return IoNil_new(ioState);
}

IoObject* io_enemy_sleep(IoObject* self, IoObject* locals, IoMessage* m) {
    Enemy elcl = handle2enemy[self];
    int t = IoMessage_locals_intArgAt_(m, locals, 0);
    elcl.sleep(t);
    return IoNil_new(ioState);
}

IoObject* io_enemy_getPlayerAngle(IoObject* self, IoObject* locals, IoMessage* m) {
    Enemy elcl = handle2enemy[self];
    float rlcl = elcl.getPlayerAngle();    return IoNumber_newWithDouble_(ioState, rlcl);
}

IoObject* io_enemy_setSpeedXY(IoObject* self, IoObject* locals, IoMessage* m) {
    Enemy elcl = handle2enemy[self];
    float sx = IoMessage_locals_floatArgAt_(m, locals, 0);
    float sy = IoMessage_locals_floatArgAt_(m, locals, 1);
    elcl.setSpeedXY(sx, sy);
    return IoNil_new(ioState);
}

void enemy_init(IoState* state, IoObject* enemy) {
    DIoObject_addMethod(state, enemy, "shotAbs", &io_enemy_shotAbs);
    DIoObject_addMethod(state, enemy, "shotAbsXY", &io_enemy_shotAbsXY);
    DIoObject_addMethod(state, enemy, "sleep", &io_enemy_sleep);
    DIoObject_addMethod(state, enemy, "getPlayerAngle", &io_enemy_getPlayerAngle);
    DIoObject_addMethod(state, enemy, "setSpeedXY", &io_enemy_setSpeedXY);
}

